#ifndef _TELNET_WINDOW_H
#	define _TELNET_WINDOW_H

#include "TelnetLooper.h"
#include "StatusView.h"

#include <ArpCommon/ArpRemoteTerminal.h>
#include <ArpCommon/ArpEmulatorManager.h>
#include <TCPSockets.h>
#include <interface/Menu.h>
#include <interface/MenuBar.h>
#include <interface/ScrollBar.h>
#include <interface/Window.h>

class TelnetWindow;

class TelnetWindow: public BWindow {
private:
	ArpRemoteTerminal *output_dev;
	StatusView *stat_view;
	BMenuBar *menu_bar;
	BMenu *edit_menu, *emulation_menu;
	BScrollBar *horiz_scroll, *vert_scroll;

	// Preferences.
	rgb_color fore_color, back_color;

	// Socket information.
	TCPLooper *io_looper;

	// The add-on emulator manager for ArpTerminal
	ArpEmulatorManager manager;

	void AddMenuBar(BRect frame);
	void ResizeToTerm(int32 rows=-1, int32 cols=-1);

public:
	TelnetWindow(BRect frame, const char *name, const char *port);
	~TelnetWindow(); 

	virtual	bool QuitRequested();
	virtual void MessageReceived(BMessage *msg);

	void SendRemote(const char *stream, int32 nbytes);
};

#endif
